import java.util.Vector;


public class ReasoningPlayer extends Player {
	
	boolean output = false;

	ReasoningPlayer(String name)
	{
		super(name);
	}
	
	
	public Card drawCard(String newOwner,  Card[] totalgame, int currindex, int round, int roundplayer)
	{
		if (output)
		{
			System.out.println("	"+name+":: Ik heb nog:  in round"+round);
			for (int i=0; i<cards.size(); i++)
				System.out.println("	"+((Card) cards.get(i)).getDescription());
		}
		
		int suit = whichSuit(totalgame,currindex,round,roundplayer);
		Vector possiblecards=possibleCards(suit);
		Card card;
		if (suit == -1)
		{
			if (output)
			{
				System.out.println("	"+name+":: Ik mag zelf de suit bepalen.");
			}
			// Yay!, we mogen zelf de suit bepalen! Laagste kaart in 1e 2 ronden, hoogste in laatste 2.
			if (round < 2)
				card = getLowestCard(cards);
			else
				card = getHighestCard(cards);
		}
		else if (possiblecards.isEmpty())
		{
			//			 We are not gonna win this round. - Let's trow away the lowest card.
	
			card = getLowestCard(cards);
			//cards.remove(cards.indexOf(card));
		}
		else
		{
			/* If we have only one suited card, we play that one.
			 * If we have more then one suited card, we play the lowest one that we need to win,'
			 * or simply the lowest if we can't win.
			 */
			if (possiblecards.size() == 1)
				card = (Card) possiblecards.get(0);
			else
			{
				/*Vector wincards = new Vector(4);
				for (int i=0; i<possiblecards.size(); i++)
					if (((Card) possiblecards.get(i)).getValue() > Game.highestcard.getValue())
						wincards.add(possiblecards.get(i));	// We can win the round with every card which has a higher value than the current winning card*/
				Vector wincards = possibleWinCards(suit);
				
				
				if (wincards.size() > 0)
				{
					card = getLowestCard(wincards);
					if (output)
					{
						System.out.println("	"+name+":: Met deze kaarten kan ik deze ronde winnen:");
						for (int i=0; i<wincards.size(); i++)
							System.out.println("	"+((Card) wincards.get(i)).getDescription());
					}
				}
				else
					card = getLowestCard(possiblecards);
					
			}
			
			// We can still win this round. Try the lowest card in the first two rounds, and the highest in the last two.
			// Wait. This is stupid. - Try to always play the highest card.
			/*if (round < 0)
				card = getLowestCard(possiblecards);
			else
				card = getHighestCard(possiblecards);*/
			
		}
		
		//Card card = cards[curnumcards-1];
		curnumcards--;
		card.setOwner(newOwner);
		playedCards.add(card);
		cards.remove(cards.indexOf(card));
		return card;
	}
}
