
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.awt.image.*;
import java.lang.Math;
import java.net.*;
// version 1.2 (added support for *.jar)
import java.net.*; 


public class ImageLoader extends Frame{
	Image img = null;
	
	public ImageLoader() {	
	}

	public BufferedImage getImageBuffered(String p,int width,int height) {
	    URL dumU = ClassLoader.getSystemResource(p);
		Image rt = null;
        boolean imageOk = true;
        
		if(dumU != null){
	       rt = Toolkit.getDefaultToolkit().getImage(dumU);	
		}
		else {
			System.out.println("Tank-N image Missing - Tank Image Disabled");
			imageOk = false;
		}
		
		if(imageOk) {
			try {
        		MediaTracker tracker = new MediaTracker(this);
           		tracker.addImage(rt, 0);
          		tracker.waitForID(0);
      		} 
      		catch (Exception e) {
      			System.out.println("image not loaded : " + p);
      		}
		}
		
		img = rt;

		BufferedImage rt1 = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);   
        Graphics2D g2 = rt1.createGraphics();
		g2.drawImage(rt,0,0,width,height,null);
		return rt1;
	} 




	public Image getImage(String p) {
	    URL dumU = ClassLoader.getSystemResource(p);
		Image rt = null;
        boolean imageOk = true;
        
		if(dumU != null){
	       rt = Toolkit.getDefaultToolkit().getImage(dumU);	
		}
		else {
			System.out.println("Tank-N image Missing - Tank Image Disabled");
			imageOk = false;
		}
		
		if(imageOk) {
			try {
        		MediaTracker tracker = new MediaTracker(this);
           		tracker.addImage(rt, 0);
          		tracker.waitForID(0);
      		} 
      		catch (Exception e) {
      			System.out.println("image not loaded : " + p);
      		}
		}
		
		img = rt;
		return rt;
	} 

}